// Freddy jack

// Created: 10/31/07 //
// Updated: 11/04/07 //

RequireSystemScript('time.js');
RequireSystemScript('screen.js');

const font = LoadFont('font.rfn'), win = LoadWindowStyle('window.rws');
const Red = CreateColor(255,0,0);
const Black = CreateColor(0,0,0);
const gray = CreateColor(0,0,0,125);
const music = LoadSound("villagefestival2.it");
const TitleM = LoadSound("spooky.mod");
const music2 = LoadSound("spooky_forest.s3m");
const music3 = LoadSound("boss.s3m");
var attack = false;
var animate = false, EAnimate = false;
var EAttack = LoadImage('EnemyAttack.png');
var frames = 0, EFrames = 0;
const Fred = LoadSpriteset('FreddyRed.rss');
const Fblue = LoadSpriteset('FreddyBlue.rss');
const Fgreen = LoadSpriteset('FreddyGreen.rss');
var m2sx = MapToScreenX, m2sy = MapToScreenY;
const Title = LoadImage('Title.png'), Arrow = LoadImage('Arrow.png');
const whoosh = LoadSound('whoosh.wav'), Select = LoadSound('Select.wav');
var can_move = true;
var move = false;
var win_game = false;
const PI = 3.141592646;
const SH = GetScreenHeight();
const SW = GetScreenWidth();
// The weapon types
function Weapon(type,img,dmg)
{
	this.type = type; // red / green / blue
	this.image = LoadImage(img);
	this.damage = dmg;
}

function ClearKeyQueue()
{ 
  while (AreKeysLeft()) GetKey(); 
}

var items = [];
// red //
items[0] = new Weapon("red",'redhoe.png',2);
items[1] = new Weapon("red",'redpitchfork.png',4)
items[2] = new Weapon("red",'redaxe.png',8);
items[3] = new Weapon("red",'reddaxe.png',12);
// blue //
items[4] = new Weapon("blue",'bluehoe.png',2);
items[5] = new Weapon("blue",'bluepitchfork.png',4)
items[6] = new Weapon("blue",'blueaxe.png',8);
items[7] = new Weapon("blue",'bluedaxe.png',12);
// green //
items[8] = new Weapon("green",'greenhoe.png',2);
items[9] = new Weapon("green",'greenpitchfork.png',4)
items[10] = new Weapon("green",'greenaxe.png',8);
items[11] = new Weapon("green",'greendaxe.png',12);

// red beats green //
// green beats blue //
// blue beats red //

var player = {}
player.hp = 10;
player.maxhp = 10;
player.weapon = items[0];
player.cweap = 0;
player.currentweapon = 0;
player.exp = 0;
player.nxp = 8;
player.cooldown = 100;
player.maxcool = 100;
player.type = "red";
player.lives = 3;
player.level = 1;

function game()
{
	var selection = 0;
	var done = false;
	TitleM.play(true);
	Title.blit(SW/2-Title.width/2,SH/2-Title.height/2);
	FadeIn(2000);
	while(!IsAnyKeyPressed())
	{
		Title.blit(SW/2-Title.width/2,SH/2-Title.height/2);
		BlinkText(SW/2-font.getStringWidth("Press Any Key")/2,SH-42,"Press Any Key");
		FlipScreen();
	}
	for(var i = 0; i < 64; ++i)
	{
		ClearScreen();
		Title.blit(SW/2-Title.width/2,SH/2-Title.height/2-i);
		FlipScreen();
	}
	Title.blit(SW/2-Title.width/2,SH/2-Title.height/2-64);
	while(AreKeysLeft()) {GetKey();}
	while(!done)
	{
		Title.blit(SW/2-Title.width/2,SH/2-Title.height/2-64);
		win.drawWindow(SW/2-50,SH/2,100,24);
		font.drawText(SW/2-34,SH/2,"New Game");
		font.drawText(SW/2-34,SH/2+12,"Quit Game");
		Arrow.blit(SW/2-50,SH/2+selection*12);
		font.drawText(SW/2-font.getStringWidth("By Radnen 2007")/2,SH-22,"By Radnen 2007");
		FlipScreen();
		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_UP: selection = 0; Select.play(false); break;
				case KEY_DOWN: selection = 1; Select.play(false); break;
				case KEY_ENTER:
				case KEY_CTRL:
					if(selection == 1) Exit();
					else done = true;
				break;
				case KEY_ESCAPE: Exit(); break;
			}
		}
	}
	Title.blit(SW/2-Title.width/2,SH/2-Title.height/2-64);
	win.drawWindow(SW/2-50,SH/2,100,24);
	font.drawText(SW/2-34,SH/2,"New Game");
	font.drawText(SW/2-34,SH/2+12,"Quit Game");
	Arrow.blit(SW/2-50,SH/2+selection*10);
	font.drawText(SW/2-font.getStringWidth("By Radnen 2007")/2,SH-22,"By Radnen 2007");
	FadeOut(2000);
	newGame();
}

function newGame()
{
	TitleM.stop();
	music3.stop();
	SetTalkActivationKey(KEY_SPACE);
	CreatePerson("freddy",'FreddyRed.rss',false);
	SetPersonIgnoreList("freddy",["Health_1","Health_2"]);
	AttachInput("freddy");
	AttachCamera("freddy");
	SetRenderScript('Render()');
	BindKey(KEY_UP,'','');
	BindKey(KEY_DOWN,'','');
	BindKey(KEY_LEFT,'','');
	BindKey(KEY_RIGHT,'','');
	SetUpdateScript('Update()');
	music.play(true);
	MapEngine("Field_01.rmp",60);
}

// The pumpkin object
function Pumpkin(life,type,name,damage,exp)
{
	this.life = life;
	this.type = type;
	this.name = name;
	this.cooldown = 80;
	this.warmup = 15;
	this.damage = damage;
	this.exp = exp;
}

var Pumpkins = [];
// This goes in the 'on_create' area.
function SetUpPumpkin(life,type,damage,exp,boss)
{
	if(damage == undefined) damage = 2;
	if(exp == undefined) exp = 4;
	var person = GetCurrentPerson();
	SetPersonValue(person,"type",type);
	Pumpkins[person] = new Pumpkin(life,type,person,damage,exp);
	SetPersonScript(person,SCRIPT_COMMAND_GENERATOR,'LifeAndDeath();');
	SetPersonScript(person,SCRIPT_ON_ACTIVATE_TALK,'Attack();');
	if(!boss) SetPersonScript(person,SCRIPT_ON_DESTROY,'Die();');
	else SetPersonScript(person,SCRIPT_ON_DESTROY,'Die(); win_game = true;');
}
// This goes in the 'on enter' area.
function Attack()
{
	if(animate)
	{
		var person = GetCurrentPerson();
		var type = GetPersonValue(person,"type");
		if (type == "red" && player.weapon.type == "blue")
			Pumpkins[person].life -= player.weapon.damage;
		if (type == "blue" && player.weapon.type == "green")
			Pumpkins[person].life -= player.weapon.damage;
		if (type == "green" && player.weapon.type == "red")
			Pumpkins[person].life -= player.weapon.damage;
	}
}
// This goes in the 'on_destroy' code box.
function Die()
{
	var person = GetCurrentPerson();
	var x = GetPersonX(person);
	var y = GetPersonY(person);
	CreatePerson(person+"_death",'death.rss',true);
	SetPersonXYFloat(person+"_death",x,y);
	for(var i = 0; i < 31; ++i) {QueuePersonCommand(person+"_death",COMMAND_ANIMATE,false);}
	SetPersonScript(person+"_death",SCRIPT_COMMAND_GENERATOR,'DeathDie();');
}
function DeathDie()
{
	var person = GetCurrentPerson();
	if(IsCommandQueueEmpty(person)) DestroyPerson(person);
}
// This goes in the 'command generator' area.
function LifeAndDeath()
{
	var person = GetCurrentPerson();
	if (Pumpkins[person].life <= 0)
	{
		player.exp += Pumpkins[person].exp;
		DestroyPerson(person);
	}
	else AttackPlayer();
}

// Render code //
function DrawLife()
{
	font.drawText(0,0,"Life:");
	font.drawText(0,10,"Level: " + player.level);
	var x = font.getStringWidth("Life:")+2;
	Rectangle(x,4,player.hp/player.maxhp*48,2,Red);
	Line(x-1,3,x+48,3,Black);
	Line(x+48,3,x+48,6,Black);
	Line(x+48,6,x-1,6,Black);
	Line(x-1,3,x-1,6,Black);
	font.drawText(SW/2-font.getStringWidth("%: 000")/2,SH-10,"%: " + Math.floor(player.cooldown/player.maxcool*100));
	font.drawText(SW-font.getStringWidth("Lives: " + player.lives),0,"Lives: " + player.lives);
}

function DrawAttack()
{
	if(animate)
	{
		var d = GetPersonDirection("freddy");
		var px = GetPersonX("freddy")-8;
		var py = GetPersonY("freddy")-8;
		if(d == "north") RotateItem(player.weapon.image,m2sx(0,px),m2sy(0,py-16),frames);
		if(d == "south") RotateItem(player.weapon.image,m2sx(0,px),m2sy(0,py+16),frames);
		if(d == "west") RotateItem(player.weapon.image,m2sx(0,px-16),m2sy(0,py),frames);
		if(d == "east") RotateItem(player.weapon.image,m2sx(0,px+16),m2sy(0,py),frames);
	}
}

function DrawEnemyAttack()
{
	if(EAnimate)
	{
		var px = GetPersonX("freddy")-8;
		var py = GetPersonY("freddy")-8;
		RotateItem(EAttack,m2sx(0,px),m2sy(0,py),EFrames);
	}
}

function Render()
{
	DrawLife()
	DrawAttack();
	DrawEnemyAttack();
}

// After every 'turn' an enemy moves closer to you.
function MoveCloser(who)
{
	var px = GetPersonX("freddy");
	var py = GetPersonY("freddy");
	var x = GetPersonX(who);
	var y = GetPersonY(who);
	if (px > x && py > y-15 && py < y+16 && !IsPersonObstructed(who,x+16,y))
	{
		SetPersonX(who,x+16);
	}
	if (px > x && py > y+16 && !IsPersonObstructed(who,x+8,y+8))
	{
		SetPersonX(who,x+16);
		SetPersonY(who,y+16);
	}
	if (py > y && px > x-15 && px < x+16 && !IsPersonObstructed(who,x,y+8))
	{
		SetPersonY(who,y+16);
	}
	if (px < x && py > y+16 && !IsPersonObstructed(who,x-8,y+8))
	{
		SetPersonY(who,y+16);
		SetPersonX(who,x-16);
	}
	if (px < x && py > y-15 && py < y+16 && !IsPersonObstructed(who,x-8,y))
	{
		SetPersonX(who,x-16);
	}
	if (px < x && py < y-15 && !IsPersonObstructed(who,x-8,y-8))
	{
		SetPersonY(who,y-16);
		SetPersonX(who,x-16)
	}
	if (py < y && px > x-15 && px < x+16 && !IsPersonObstructed(who,x,y-8))
	{
		SetPersonY(who,y-16);
	}
	if (px > x && py < y-15 && !IsPersonObstructed(who,x+8,y-8))
	{
		SetPersonY(who,y-16);
		SetPersonX(who,x+16);
	}
}

// Movement Commands //
function MoveVertical(y)
{
	var px = GetPersonX("freddy");
	var py = GetPersonY("freddy");
	if (y < 0)
	{
		if (!IsPersonObstructed("freddy",px,py-8)) SetPersonY("freddy",py+y);
		SetPersonDirection("freddy","north");
	}
	else
	{
		if (!IsPersonObstructed("freddy",px,py+8)) SetPersonY("freddy",py+y);
		SetPersonDirection("freddy","south");
	}
}

function MoveHorizontal(x)
{
	var px = GetPersonX("freddy");
	var py = GetPersonY("freddy");
	if (x < 0)
	{
		if (!IsPersonObstructed("freddy",px-8,py)) SetPersonX("freddy",px+x);
		SetPersonDirection("freddy","west");
	}
	else
	{
		if (!IsPersonObstructed("freddy",px+8,py)) SetPersonX("freddy",px+x);
		SetPersonDirection("freddy","east");
	}
}

function wait(milliseconds)
{
	var time = GetTime();
	while(milliseconds+time > GetTime())
	{
		UpdateMapEngine(); RenderMap(); FlipScreen();
	}
}

function Movement()
{
	while(AreKeysLeft() && !animate)
	{
		switch(GetKey())
		{
			case KEY_UP: if(can_move){MoveVertical(-16); move = true;}
			break;
			case KEY_DOWN: if(can_move){MoveVertical(16); move = true;}
			break;
			case KEY_LEFT: if(can_move){MoveHorizontal(-16); move = true;}
			break;
			case KEY_RIGHT: if(can_move){MoveHorizontal(16); move = true;}
			break;
			case KEY_SPACE: if(!attack && player.cooldown == player.maxcool) attack = true;
			break;
			case KEY_1: player.weapon = items[0+player.cweap]; player.currentweapon = 0;
				SetPersonSpriteset("freddy",Fred); player.type = "red";
			break;
			case KEY_2: player.weapon = items[4+player.cweap]; player.currentweapon = 4;
				SetPersonSpriteset("freddy",Fblue); player.type = "blue";
			break;
			case KEY_3: player.weapon = items[8+player.cweap]; player.currentweapon = 8;
				SetPersonSpriteset("freddy",Fgreen); player.type = "green";
			break;
			case KEY_ESCAPE: Menu();
			break;
		}
		if(move)
		{
			var people = GetPersonList();
			for(var i = 0; i < people.length; ++i)
			{
				if(Pumpkins[people[i]] != undefined)
					MoveCloser(Pumpkins[people[i]].name);
			}
			move = false;
		}
		wait(10);
	}
}

// update
function Update()
{
	Movement();
	AttackStuff();
	if(player.exp >= player.nxp) {player.nxp += player.nxp+player.nxp/4; LevelUp();}
	if(player.hp <= 0) {Delay(100); GameOver();}
	if(win_game)
	{
		drawTextBox("You have deafeated the wild enemy that lurks in these forests. I salute you!");
		RenderMap();
		FadeOut(2000);
		RestartGame();
	}
}

// Player Attack //

function AttackStuff()
{
	if(attack)
	{
		animate = true;
		player.cooldown = 0;
		whoosh.play(false);
		attack = false;
	}
	if(animate)
	{
		frames++;
		if(frames == 24) {frames = 0; animate = false;}
	}
	if(EAnimate)
	{
		EFrames++;
		if(EFrames == 24) {EFrames = 0; EAnimate = false;}
	}
	if(player.cooldown != player.maxcool)
		player.cooldown++;
}

function RotateItem(img,x,y,frames)
{
	if(frames > 0 && frames < 9) img.rotateBlit(x,y,1*PI);
	if(frames > 8 && frames < 17) img.rotateBlit(x,y,1.5*PI);
	if(frames > 16 && frames < 25) img.rotateBlit(x,y,2*PI);
}

function Teleport(map,x,y)
{
	can_move = false;
	x = (x*16)+7;
	y = (y*16)+7;
	RenderMap();
	FadeOut(1000);
	ChangeMap(map);
	SetPersonXYFloat("freddy",x,y);
	UpdateMapEngine();
	RenderMap();
	FadeIn(1000);
	can_move = true;
}

// Enemy Attacking //
function AttackPlayer()
{
	var person = GetCurrentPerson();
	var px = GetPersonX("freddy");
	var py = GetPersonY("freddy");
	var x = GetPersonX(person);
	var y = GetPersonY(person);
	if(Pumpkins[person].cooldown == 0)
	{
		if(Pumpkins[person].type != player.type)
		{
			if (py < y && py > y-24 && px > x-8 && px < x+8) DamagePlayer(person);
			else if (py > y && py < y+24 && px > x-8 && px < x+8) DamagePlayer(person);
			else if (px < x && px > x-24 && py > y-8 && py < y+8) DamagePlayer(person);
			else if (px > x && px < x+24 && py > y-8 && py < y+8) DamagePlayer(person);
		}
	}
	if(Pumpkins[person].cooldown > 0) Pumpkins[person].cooldown--;
}

function DamagePlayer(person)
{
	Pumpkins[person].warmup--;
	if(Pumpkins[person].warmup == 0)
	{
		player.hp-=Pumpkins[person].damage;
		Pumpkins[person].cooldown = 80;
		Pumpkins[person].warmup = 15;
		EAnimate = true;
	}
}

function LevelUp()
{
	var selection = 0;
	var done = false;
	player.level++;
	while(!done)
	{
		RenderMap();
		Rectangle(0,0,SW,SH,gray);
		win.drawWindow(SW/2-50,SH/2-18,100,36);
		font.drawText(SW/2-40,SH/2-18,"Up speed");
		font.drawText(SW/2-40,SH/2-6,"Up attack");
		font.drawText(SW/2-40,SH/2+8,"Up health");
		Arrow.blit(SW/2-50,SH/2-18+selection * 12);
		FlipScreen();
		if(player.maxhp == 52 && player.cweap == 3 && player.maxcool == 25) done = true;
		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_UP:
					if(selection > 0) selection--;
				break;
				case KEY_DOWN:
					if (selection < 2) selection++;
				break;
				case KEY_CTRL:
				case KEY_ENTER:
					if(selection == 0 && player.maxcool > 50)
					{
						player.maxcool -= 25;
						player.cooldown = player.maxcool;
						done = true;
					}
					if(selection == 1 && player.cweap < 3)
					{
						player.cweap++;
						player.weapon = items[player.currentweapon+player.cweap];
						done = true;
					}
					if(selection == 2 && player.maxhp < 34)
					{
						player.maxhp+=8;
						player.hp = player.maxhp;
						done = true;
					}
				break;
			}
		}
	}
}

function GameOver()
{
	ClearKeyQueue();
	var selection = 0;
	var done = false;
	while(!done)
	{
		RenderMap();
		Rectangle(0,0,SW,SH,gray);
		BlinkText(SW/2-font.getStringWidth("Game Over")/2,SH/2-58,"Game Over");
		if(player.lives > 0)
		{
			win.drawWindow(SW/2-50,SH/2-6,100,24);
			Arrow.blit(SW/2-50,SH/2-6+selection*12);
			font.drawText(SW/2-40,SH/2-6,"Continue?");
			font.drawText(SW/2-40,SH/2+6,"Restart?")
		}
		FlipScreen();
		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_UP: selection = 0; break;
				case KEY_DOWN: selection = 1; break;
				case KEY_CTRL:
				case KEY_ENTER:
				if(player.lives > 0)
				{
					if(selection == 0) {player.hp = player.maxhp; player.lives--; done = true;}
					if(selection == 1) {RestartGame(); return;}
				}
				else RestartGame();
				break;
			}
		}
	}
}

function Menu()
{
	var done = false;
	var selection = 0;
	while(!done)
	{
		RenderMap();
		Rectangle(0,0,SW,SH,gray);
		win.drawWindow(SW/2-50,SH/2,100,24);
		font.drawText(SW/2-34,SH/2,"Restart");
		font.drawText(SW/2-34,SH/2+12,"Cancel");
		Arrow.blit(SW/2-50,SH/2+selection*12);
		FlipScreen();
		while(AreKeysLeft())
		{
			switch(GetKey())
			{
				case KEY_UP: selection = 0; Select.play(false); break;
				case KEY_DOWN: selection = 1; Select.play(false); break;
				case KEY_ENTER:
				case KEY_CTRL:
					if(selection == 0) RestartGame();
					else done = true;
				break;
				case KEY_ESCAPE: done = true; break;
			}
		}
	}
}

function BlinkText(x,y,txt)
{
	var date = new Date;
	var milliseconds = date.getMilliseconds();
	if (milliseconds > 500) font.drawText(x,y,txt);
}

function Potion()
{
	var px = GetPersonX("freddy");
	var py = GetPersonY("freddy");
	var x = GetPersonX(GetCurrentPerson());
	var y = GetPersonY(GetCurrentPerson());
	if(px > x-8 && px < x+8 && py > y-8 && py < y+8)
	{
		player.hp = player.maxhp;
		DestroyPerson(GetCurrentPerson());
	}
}

function drawTextBox(txt)
{
	ClearKeyQueue();
	while(!IsKeyPressed(KEY_ENTER))
	{
		RenderMap();
		Rectangle(0,0,SW,SH,gray);
		win.drawWindow(SW/2-120,SH/2-80,240,160);
		font.drawTextBox(SW/2-120,SH/2-80,240,160,0,txt);
		BlinkText(SW/2-font.getStringWidth("Press ENTER")/2,SH-42,"Press ENTER");
		FlipScreen();
	}
}

var intro1 = false;
var intro2 = false;
var intro3 = false;
var intro4 = false;

function Intro1()
{
	if(!intro1)
	{
		drawTextBox("Welcome to Freddy Jack in Spookland! You're on a mission to reclaim the Forbidden " +
		"Forest! And I need your help! I know this task will seem hard and long but you'll get used to it. " +
		"It'll be well worth the effort in the end.");
		Delay(200);
		drawTextBox("There is an enemy in this room and he's mad. He's what we call a changling. He used to " +
		"be a pumpkin, but now he's an evil monster who changed color to be vile and repulsive. It's your job " +
		"to use common farm tools to beat the living crap out of these monsters. This isn't a childs game.");
		Delay(200);
		drawTextBox("Press the SPACEBAR to attack the enemies. They'll attack you so make sure YOU don't die. " +
		"Sounds easy? Well, my friend, it's not. Mwahahahaha!");
		intro1 = true;
	}
}

function Intro2()
{
	if(!intro2)
	{
		drawTextBox("And you thought those enemies were easy? From here on out you'll need to use all of your " +
		"skills. See, the enemies have 3 colors, red, green, and blue. You have three weapons a red, blue and "+ 
		"green weapon. Blue is weak to green, red is weak to blue and green is weak to red.");
		Delay(200);
		drawTextBox("Remember this lad, for it's these weapons that will help you on your quest. Oh, and one " +
		"more thing. Press 1 for red weapon, 2 for blue, and 3 for green. This'll help you switch your weapon " +
		"so killing can commence. Remember, to beat the forest you'll need to BE the forest! Mwahahahaha!");
		Delay(200);
		drawTextBox("Also, to make it easier, if you are the same color as the enemy, no damage will be done " +
		"to you. You'll become imune to them. But, then again, you won't be able to damage that creature so " +
		"they'll be imune to you. Yet this will have it's purposses as you get adjusted... To killing.");
		intro2 = true;
	}
}

function Intro3()
{
	if(!intro3)
	{
		drawTextBox("Now, you have entered the forest. Yes, THE Forbidden Forest. What foul fortunes are you " +
		"possibly going to solve? What foul beast awaits your testament? There is only death, boy. Turn around " +
		"leave this place! There is nothing for you here. You won't possibly win.");
		intro3 = true;
	}
}

function Intro4()
{
	if(!intro4)
	{
		drawTextBox("Mwahaha! You have proven yourself worthy! Now you get to meet me! I AM THE FOREST! and I " +
		"have been waiting for you. Do you think you got what it takes to beat me? Have you mastered your skills? " +
		"I'm warning you right here, back away, or you shall die! Mwahahahaha!");
		intro4 = true;
	}
}